Bug 1098424 - tycho: Java class bundling/"static linking"
Summary: tycho: Java class bundling/"static linking"
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: tycho
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Roland Grunberg
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 789272
Blocks: 1098237
TreeView+ depends on / blocked
 
Reported: 2014-05-16 07:36 UTC by Florian Weimer
Modified: 2017-12-12 10:17 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:17:54 UTC


Attachments (Terms of Use)

Description Florian Weimer 2014-05-16 07:36:34 UTC
tycho-0.20.0-6.fc21.noarch bundles many class files which are also available from other Fedora packages.  Here are a few examples:

/usr/share/java/tycho/org.eclipse.tycho.surefire.junit.jar contains org/apache/maven/surefire/common/junit3/JUnit3Reflector, also part of maven-surefire-provider-junit-0:2.17-1.fc21.noarch.  /usr/share/java/tycho/org.eclipse.tycho.surefire.junit4.jar contains org/apache/maven/surefire/common/junit3/JUnit3TestChecker, also from maven-surefire-provider-junit-0:2.17-1.fc21.noarch.

/usr/share/java/tycho/org.eclipse.tycho.surefire.osgibooter.jar contains the class org/codehaus/plexus/util/AbstractScanner, which is part of plexus-utils-3.0.16-2.fc21.noarch.

/usr/share/java/tycho/tycho-bundles-external.zip contains org/apache/commons/logging/Log from apache-commons-logging-1.1.3-11.fc21.noarch, org/apache/commons/codec/BinaryDecoder from apache-commons-codec-1.9-2.fc21.noarch, org/apache/http/auth/AUTH from httpcomponents-client-4.3.3-1.fc21.noarch, org/apache/http/ConnectionClosedException from httpcomponents-core-4.3.2-1.fc21.noarch, org/sat4j/AbstractLauncher from sat4j-2.3.5-3.fc21.noarch.

It seems that at least some of these class files are copied from build dependencies into the JAR files of the tycho RPM. Such bundling/static linking is against the Fedora packaging guidelines, specifically <http://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries>.

Comment 1 Roland Grunberg 2014-05-21 20:00:14 UTC
For tycho-bundles-external (Bug 789272), we would likely need to change Tycho's runtime to do some resolution of their actual locations. Eclipse dependencies aren't mavenized so xmvn can't help here, and zipping symlinks would require a Tycho rebuild per Eclipse rebuild.

As for the other bundled libraries, they're present in Bundle-ClassPath, so they are needed only for the OSGi runtime. If we make maven-surefire, and plexus-utils OSGi bundles (provide some special headers in their jar manifests) then this can be fixed.

I haven't had too much time improve the state of how Tycho is shipped, but this will be the main item on my list.

Comment 2 Roland Grunberg 2014-09-11 13:41:24 UTC
As of http://pkgs.fedoraproject.org/cgit/tycho.git/commit/?id=793ac795c5202b40886f158ad18272f50590d355 (tycho-0.21.0-7), tycho-bundles-external.zip and tycho-standalone-p2-director.zip no longer bundle system jars. Using some additional symlinks in Eclipse (http://pkgs.fedoraproject.org/cgit/eclipse.git/commit/?id=6a3b1d5b09d6dc6fd5f03f942040befe10cfe068) we won't have to re-bootstrap Tycho on every version/qualifier change in Eclipse.

All that is left to address is : org.eclipse.tycho.surefire.osgibooter, org.eclipse.tycho.surefire.junit47, org.eclipse.tycho.surefire.junit4 and org.eclipse.tycho.surefire.junit (for maven-surefire and plexus-utils jar bundling).

Comment 3 Jaroslav Reznik 2015-03-03 17:01:38 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22

Comment 4 Fedora End Of Life 2016-07-19 11:31:45 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 5 Jan Kurik 2016-07-26 04:58:33 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.

Comment 6 Fedora End Of Life 2017-11-16 19:18:38 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 7 Fedora End Of Life 2017-12-12 10:17:54 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.